//+------------------------------------------------------------------+
//|                                              Madro  Original     |
//|                                         Copyright  2007, madro  |
//|                                               madrofx@yahoo.com  |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2007, madro"
#property  link      "madrofx@yahoo.com"
//----
#property indicator_separate_window    
#property indicator_buffers  8
#property indicator_minimum  0
#property indicator_maximum  1
#property indicator_color1 RoyalBlue
#property indicator_color2 OrangeRed
#property indicator_color3 Goldenrod
#property indicator_color4 DarkGray
#property indicator_color5 Goldenrod
#property indicator_color6 DarkGray
#property indicator_color7 Goldenrod
#property indicator_color8 Gray
//----

//EMA
extern int FasterEMA1 = 5;
extern int SlowerEMA1 = 15;
extern int FasterEMA2 = 9;
extern int SlowerEMA2 = 30;
extern int slowerSMMA3= 15;


extern int MA1_Type = 0; //SMA
extern int MA2_Type = 1; //EMA
extern int MA3_Type = 2; //SMMA

//MACD
extern int MACD_Fast = 8;
extern int MACD_Slow = 17;
extern int MACD_Signal = 9; 

//RSI
extern int RSI = 21;

//Momentum
extern int Momentum = 14;

//DeMarker
extern int DeMarker = 14;

//ADX
extern int ADX = 14;

// Force Index
extern int ForceIndex = 14;


extern bool SoundAlert = true;
//---- indicator buffers
double Up[];
double Down[];
double CrossUp[];
double CrossDown[];
double TrendUp[];
double TrendDown[];
double MAUp[];
double MADown[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
//---- indicator line
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0,120);
   SetIndexBuffer(0, Up);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1,120);
   SetIndexBuffer(1, Down);
   SetIndexStyle(2, DRAW_ARROW);
   SetIndexArrow(2, 251);
   SetIndexBuffer(2, CrossUp);
   SetIndexStyle(3, DRAW_ARROW);
   SetIndexArrow(3, 251);
   SetIndexBuffer(3, CrossDown);
   SetIndexStyle(4, DRAW_ARROW);
   SetIndexArrow(4, 110);
   SetIndexBuffer(4, TrendUp);
   SetIndexStyle(5, DRAW_ARROW);
   SetIndexArrow(5, 110);
   SetIndexBuffer(5, TrendDown);
   SetIndexStyle(6, DRAW_ARROW,0,1);
   SetIndexArrow(6, 241);
   SetIndexBuffer(6, MAUp);
   SetIndexStyle(7, DRAW_ARROW,0,1);
   SetIndexArrow(7, 242);
   SetIndexBuffer(7, MADown);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("madro-9");
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|  GoldenFilter_v1                                                 |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars = IndicatorCounted();
   int i;
   int limit;
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;
   limit = Bars - counted_bars;
//----   
   for(i = limit - 1; i >= 0; i--)
     {	
       //---- 
       //EMA1
	    double  fasterEMAnow1 = iMA(NULL, 0, FasterEMA1, 0, MA2_Type, 
	                                PRICE_CLOSE, i);
       double  fasterEMAprevious1 = iMA(NULL, 0, FasterEMA1, 0, MA2_Type, 
                                      PRICE_CLOSE, i + 1);
       double  fasterEMAafter1 = iMA(NULL, 0, FasterEMA1, 0, MA2_Type, 
                                   PRICE_CLOSE, i - 1);
       double  slowerEMAnow1 = iMA(NULL, 0, SlowerEMA1, 0, MA2_Type, 
                                 PRICE_CLOSE, i);
       double  slowerEMAprevious1 = iMA(NULL, 0, SlowerEMA1, 0, 
                                      MA2_Type, PRICE_CLOSE, i + 1);
       double  slowerEMAafter1 = iMA(NULL, 0, SlowerEMA1, 0, MA2_Type, 
                                   PRICE_CLOSE, i - 1);
       //---- 
       //EMA 2
       double  fasterEMAnow2 = iMA(NULL, 0, FasterEMA2, 0, MA2_Type, 
	                                PRICE_CLOSE, i);
       double  fasterEMAprevious2 = iMA(NULL, 0, FasterEMA2, 0, MA2_Type, 
                                      PRICE_CLOSE, i + 1);
       double  fasterEMAafter2 = iMA(NULL, 0, FasterEMA2, 0, MA2_Type, 
                                   PRICE_CLOSE, i - 1);
       double  slowerEMAnow2 = iMA(NULL, 0, SlowerEMA2, 0, MA2_Type, 
                                 PRICE_CLOSE, i);
       double  slowerEMAprevious2 = iMA(NULL, 0, SlowerEMA2, 0, 
                                      MA2_Type, PRICE_CLOSE, i + 1);
       double  slowerEMAafter2 = iMA(NULL, 0, SlowerEMA2, 0, MA2_Type, 
                                   PRICE_CLOSE, i - 1);
       
       //SMMA3
       double  slowerSMMAnow3 = iMA(NULL, 0, slowerSMMA3, 0, MA3_Type, 
                                 PRICE_CLOSE, i);
       double  slowerSMMAprevious3 = iMA(NULL, 0, slowerSMMA3, 0, 
                                      MA3_Type, PRICE_CLOSE, i + 1);
       double  slowerSMMAafter3 = iMA(NULL, 0, slowerSMMA3, 0, MA3_Type, 
                                   PRICE_CLOSE, i - 1);                            
                                   
                                   
       //---- 
       double  MACD = iMACD(Symbol(), Period(), MACD_Fast, MACD_Slow, 
                            MACD_Signal, PRICE_CLOSE, MODE_MAIN, i);
       double  MACD_Sig = iMACD(Symbol(), Period(), MACD_Fast, MACD_Slow,
                                MACD_Signal, PRICE_CLOSE, MODE_SIGNAL, i);
       //---- 
       double  ADX1 = iADX(NULL, 0, ADX, PRICE_CLOSE, MODE_PLUSDI, i);
       double  ADX2 = iADX(NULL, 0, ADX, PRICE_CLOSE, MODE_MINUSDI, i);
       //----
       double  RSIV = iRSI(NULL, 0, RSI, 0, i);
       double  DEM = iDeMarker(NULL, 0, DeMarker, i); 
       double  MOM = iMomentum( NULL,0, Momentum, PRICE_CLOSE, i); 
       double  FI = iForce(NULL, 0, ForceIndex, 1, PRICE_CLOSE, i);
       
	 	
	 	
	 	
	 	
	 	
	 	 //Broken Trend
       //////////////
       if((fasterEMAnow2 > slowerEMAnow2) && 
          (fasterEMAprevious2 < slowerEMAprevious2) && 
          (fasterEMAafter2 > slowerEMAafter2)&& (MOM > 100))
	 	    Up[i] = 0.05;
	 	    
	 	    
       if((fasterEMAnow2 < (slowerEMAnow2)) && 
          (fasterEMAprevious2 > (slowerEMAprevious2)) && 
          (fasterEMAafter2 < slowerEMAafter2)&&(MOM <= 100))  
          Down[i] = 0.05;
       
       //Golden Trend
       //////////////
       if((fasterEMAnow1 > (slowerSMMAnow3)) && 
          (fasterEMAprevious1 < slowerSMMAprevious3) && 
          (fasterEMAafter1 > slowerSMMAafter3)&& (DEM > 0.5 && FI >0) )
          TrendUp[i] = 0.22;
          
       if((fasterEMAnow1 < (slowerSMMAnow3)) && 
          (fasterEMAprevious1 > slowerSMMAprevious3) && 
          (fasterEMAafter1 < slowerSMMAafter3)&& (DEM < 0.5 && FI <0) )
          TrendDown[i] = 0.22;         
       
       //Golden Cross
       //////////////
       if(RSIV > 50 && MACD > MACD_Sig && ADX1 > ADX2)
           CrossUp[i] = 0.47;
       if(RSIV < 50 && MACD < MACD_Sig && ADX1 < ADX2)
           CrossDown[i] = 0.47; 
       
       //Golden Line
       //////////////
       if((fasterEMAnow1 > slowerEMAnow1) && 
          (fasterEMAprevious1 < slowerEMAprevious1) && 
          (fasterEMAafter1 > slowerEMAafter1))
         {
           MAUp[i] = 0.8;
           if(SoundAlert == true)
             {
               Alert("GoldenMadro Up " + Symbol() + " on the " + 
                     Period() + " minute chart.");
             }
         }
       if((fasterEMAnow1 < (slowerEMAnow1)) && 
          (fasterEMAprevious1 > (slowerEMAprevious1)) && 
          (fasterEMAafter1 < slowerEMAafter1))  
         {
           MADown[i] = 0.8;
           if(SoundAlert == true)
               Alert(" GoldenMadro Up " + Symbol() + " on the " + 
                     Period() + " minute chart.");
         } 
       
     }  
   return(0);	
  }
//+------------------------------------------------------------------+



